﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace TechnoAP.usbmca.common
{
    /// <summary>
    /// Summary for binary
    /// </summary>
    public class binary
    {
        /// <summary>
        /// Extraction of lower 32 bits
        /// </summary>
        public static uint getLsb32bit(long value)
        {
            return (uint)(value & (long)0x0ffffffff);
        }

        /// <summary>
        /// Extraction of upper 32 bits
        /// </summary>
        public static uint getMsb32bit(long value)
        {
            return (uint)((value >> 32) & (long)0x0ffffffff);
        }

        /// <summary>
        /// Enhancement from 48 bits to 64 bits
        /// </summary>
        public static long expand48bitTo64bit(byte[] source, int offset)
        {
            long lngResult;

            byte[] abTemp = new byte[8];
            Buffer.BlockCopy(source, offset, abTemp, 2, 6);

            lngResult = BitConverter.ToInt64(abTemp, 0);
            lngResult = System.Net.IPAddress.HostToNetworkOrder(lngResult);

            return lngResult;
        }

        /// <summary>
        /// Enhancement from 24 bits to 32 bits(host byte order)
        /// </summary>
        public static int expand24bitTo32bit(byte[] source, int offset)
        {
            int intResult;

            byte[] abTemp = new byte[4];
            Array.Clear(abTemp, 0, abTemp.Length);
            Buffer.BlockCopy(source, offset, abTemp, 1, 3);

            intResult = BitConverter.ToInt32(abTemp, 0);
            intResult = System.Net.IPAddress.HostToNetworkOrder(intResult);

            return intResult;

        }

        /// <summary>
        /// Conversion from 4 byte array to 32 bit variable(host byte order)
        /// </summary>
        public static int arrayToUnit32bit(byte[] source, int offset)
        {
            int intResult;

            byte[] abTemp = new byte[4];
            Array.Clear(abTemp, 0, abTemp.Length);
            Buffer.BlockCopy(source, offset, abTemp, 0, 4);

            intResult = BitConverter.ToInt32(abTemp, 0);
            intResult = System.Net.IPAddress.HostToNetworkOrder(intResult);

            return intResult;

        }

        /// <summary>
        /// Reduce from 48 bits to 32 bits (as an array)
        /// </summary>
        public static byte[] contract64bitTo48bit(long value)
        {
            byte[] abResult = new byte[6];

            long wvalue = System.Net.IPAddress.NetworkToHostOrder(value);
            byte[] abWork = BitConverter.GetBytes(wvalue);
            Buffer.BlockCopy(abWork, 2, abResult, 0, abResult.Length);

            return abResult;

        }
    }
}
