﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TechnoAP.usbmca.common
{
    /// <summary>
    /// Summary for convert
    /// </summary>
    public class convert
    {
        public const long mMissecondsPerCount = 25000000;

        /// <summary>
        /// Nano seconds -> count conversion
        /// </summary>
        public static long NanosecondsToCount(long value)
        {
            long result = value / TechnoAP.usbmca.constant.Unit.CountPerDigitNsec;
            return result;
        }

        /// <summary>
        /// Milliseconds -> count conversion
        /// </summary>
        public static long MillisecondsToCount(long value)
        {
            return NanosecondsToCount(value * 1000000);
        }

        /// <summary>
        /// Seconds -> count conversion
        /// </summary>
        public static long SecondsToCount(long value)
        {
            return MillisecondsToCount(value * 1000);
        }

        // count -> time
        /// <summary>
        /// Count -> nano seconds conversion
        /// </summary>
        public static long CountToNanoseconds(long count)
        {
            return (count * TechnoAP.usbmca.constant.Unit.CountPerDigitNsec);
        }

        /// <summary>
        /// Count -> milliseconds conversion
        /// </summary>
        public static long CountToMilliseconds(long count)
        {
            return (CountToNanoseconds(count) / 1000000);
        }
    }
}
