﻿using System;

namespace TechnoAP.usbmca.data
{
    /// <summary>
    /// Summary for list
    /// </summary>
    public class list
    {
        public long mlngAbs = 0;        // absolute time
        public int mnCH = 0;            // CH number
        public int mnPHA = 0;           // pulse height analyzer

        public time mTime = new time();

        /// <summary>
        /// Time conversion class
        /// </summary>
        public class time
        {
            public long mlngTotalNanoseconds = 0;
            public long mlngSeconds = 0;
            public int mnMilliseconds = 0;
            public int mnMicroseconds = 0;
            public int mnNanoseconds = 0;

            public void Analyze(long lngNanoseconds)
            {
                long tmpTime = lngNanoseconds;

                mlngTotalNanoseconds = tmpTime;
                mnNanoseconds = (int)(tmpTime % 1000);
                tmpTime /= 1000;
                mnMicroseconds = (int)(tmpTime % 1000);
                tmpTime /= 1000;
                mnMilliseconds = (int)(tmpTime % 1000);
                tmpTime /= 1000;
                mlngSeconds = (long)(tmpTime);
                tmpTime /= 1000;
            }
        }

        /// <summary>
        /// constractor
        /// </summary>
        public list()
        {
            mlngAbs = 0;
            mnCH = 0;
            mnPHA = 0;
        }

        /// <summary>
        /// constractor, with adjusting
        /// </summary>
        public list(byte[] abListData)
        {
            Adjust(abListData);
        }

        /// <summary>
        /// adjusting list data
        /// </summary>
        public void Adjust(byte[] abListData)
        {
            byte[] abTemp = new byte[sizeof(long)];

            Array.Clear(abTemp, 0, abTemp.Length);
            Buffer.BlockCopy(abListData, 0, abTemp, 2, 6);
            long tmp64bit = BitConverter.ToInt64(abTemp, 0);
            short tmp16bit = BitConverter.ToInt16(abListData, 6);

            tmp64bit = System.Net.IPAddress.NetworkToHostOrder(tmp64bit);
            tmp16bit = System.Net.IPAddress.NetworkToHostOrder(tmp16bit);

            mlngAbs = (long)(tmp64bit & 0x0fffffffffff);
            mnCH = (int)(((tmp16bit >> 14) & 0x03) + 1);
            mnPHA = (int)(tmp16bit & 0x3fff);

            long lngNanoseconds = common.convert.CountToNanoseconds(mlngAbs);
            mTime.Analyze(lngNanoseconds);
        }

        /// <summary>
        /// create list data (detail)
        /// </summary>
        public static list createList(byte[] abListData)
        {
            return  (new list(abListData));
        }
    }
}

