﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using TechnoAP.usbmca;

namespace TechnoAP.usbmca.device
{
    /// <summary>
    /// Summary for status
    /// </summary>
    public class status
    {
        /// <summary>
        /// Summary for status_ch(CH unit) 
        /// </summary>
        public class status_ch
        {
            public long mLiveTime;
            public long mDeadTime;
            public uint mThroughputRate;
            public uint mThroughputCount;
            public uint mInputRate;
        }
        
        public long mRealTime;
        public status_ch[] maChannel = new status_ch[constant.Max.CH];

        public status()
        {
            for(int i = 0; i < maChannel.Length; i++)
            {
                maChannel[i] = new status_ch();
            }
        }

        public status analyzeData(byte[] abStatus)
        {
            mRealTime = common.binary.expand48bitTo64bit(abStatus, 0);

            for (int i = 0; i < maChannel.Length; i++)
            {
                int index = 6 + (22 * i);
                maChannel[i].mLiveTime = common.binary.expand48bitTo64bit(abStatus, (index + 0));
                maChannel[i].mDeadTime = common.binary.expand48bitTo64bit(abStatus, (index + 6));
                maChannel[i].mThroughputRate = (uint)common.binary.expand24bitTo32bit(abStatus, (index + 12));
                maChannel[i].mThroughputCount = (uint)common.binary.arrayToUnit32bit(abStatus, (index + 15));
                maChannel[i].mInputRate = (uint)common.binary.expand24bitTo32bit(abStatus, (index + 19));
            }

            return this;

        }

        public long getElapsedTimeMilliseconds()
        {
            return TechnoAP.usbmca.common.convert.CountToMilliseconds(mRealTime);
        }

        public long getElapsedTimeNanoseconds()
        {
            return TechnoAP.usbmca.common.convert.CountToNanoseconds(mRealTime);
        }
    }
}
